Public Member Functions | Protected Member Functions | Static Protected Member Functions

# OGRCompoundCurve Class Reference

Concrete representation of a compound curve, made of curves: OGRLineString and OGRCircularString. More...

`#include <ogr_geometry.h>`

Inheritance diagram for OGRCompoundCurve:

List of all members.

## Public Member Functions
| OGRCompoundCurve ()
| Create an empty compound curve.
virtual int | WkbSize () const
| Returns size of related binary representation.
virtual OGRErr | importFromWkb (unsigned char *, int=-1, OGRwkbVariant=wkbVariantOldOgc)
| Assign geometry from well known binary data.
virtual OGRErr | exportToWkb (OGRwkbByteOrder, unsigned char *, OGRwkbVariant=wkbVariantOldOgc) const
| Convert a geometry into well known binary format.
virtual OGRErr | importFromWkt (char **)
| Assign geometry from well known text data.
virtual OGRErr | exportToWkt (char **ppszDstText, OGRwkbVariant=wkbVariantOldOgc) const
| Convert a geometry into well known text format.
virtual OGRGeometry * | clone () const
| Make a copy of this object.
virtual void | empty ()
| Clear geometry information.
virtual void | getEnvelope (OGREnvelope *psEnvelope) const
| Computes and returns the bounding envelope for this geometry in the passed psEnvelope structure.
virtual void | getEnvelope (OGREnvelope3D *psEnvelope) const
| Computes and returns the bounding envelope (3D) for this geometry in the passed psEnvelope structure.
virtual OGRBoolean | IsEmpty () const
| Returns TRUE (non-zero) if the object has no points.
virtual double | get_Length () const
| Returns the length of the curve.
virtual void | StartPoint (OGRPoint *) const
| Return the curve start point.
virtual void | EndPoint (OGRPoint *) const
| Return the curve end point.
virtual void | Value (double, OGRPoint *) const
| Fetch point at given distance along curve.
virtual OGRLineString * | CurveToLine (double dfMaxAngleStepSizeDegrees=0, const char *const *papszOptions=NULL) const
| Return a linestring from a curve geometry.
virtual int | getNumPoints () const
| Return the number of points of a curve geometry.
virtual double | get_AreaOfCurveSegments () const
| Get the area of the purely curve portions of a (closed) curve.
virtual double | get_Area () const
| Get the area of the (closed) curve.
virtual OGRBoolean | Equals (OGRGeometry *) const
| Returns TRUE if two geometries are equivalent.
int | getNumCurves () const
| Return the number of curves.
OGRCurve * | getCurve (int)
| Fetch reference to indicated internal ring.
const OGRCurve * | getCurve (int) const
| Fetch reference to indicated internal ring.
virtual void | setCoordinateDimension (int nDimension)
| Set the coordinate dimension.
OGRErr | addCurve (OGRCurve *, double dfToleranceEps=1e-14)
| Add a curve to the container.
OGRErr | addCurveDirectly (OGRCurve *, double dfToleranceEps=1e-14)
| Add a curve directly to the container.
OGRCurve * | stealCurve (int)
virtual OGRPointIterator * | getPointIterator () const
| Returns a point iterator over the curve.
virtual OGRwkbGeometryType | getGeometryType () const
| Fetch geometry type.
virtual const char * | getGeometryName () const
| Fetch WKT name for geometry type.
virtual OGRErr | transform (OGRCoordinateTransformation *poCT)
| Apply arbitrary coordinate transformation to geometry.
virtual void | flattenTo2D ()
| Convert geometry to strictly 2D.
virtual void | segmentize (double dfMaxLength)
| Add intermediate vertices to a geometry.
virtual OGRBoolean | hasCurveGeometry (int bLookForNonLinear=FALSE) const
virtual OGRGeometry * | getLinearGeometry (double dfMaxAngleStepSizeDegrees=0, const char *const *papszOptions=NULL) const
virtual void | swapXY ()
| Swap x and y coordinates.
## Protected Member Functions
virtual OGRCurveCasterToLineString | GetCasterToLineString () const
virtual OGRCurveCasterToLinearRing | GetCasterToLinearRing () const
## Static Protected Member Functions
static OGRLineString * | CastToLineString (OGRCompoundCurve *poCC)
static OGRLinearRing * | CastToLinearRing (OGRCompoundCurve *poCC)
| Cast to linear ring.

## Detailed Description

Concrete representation of a compound curve, made of curves: OGRLineString and OGRCircularString.

Each curve is connected by its first point to the last point of the previous curve.

Compatibility: ISO SQL/MM Part 3.

Since:
  GDAL 2.0

## Member Function Documentation

OGRErr OGRCompoundCurve::addCurve | ( | OGRCurve * | poCurve,
|  | double | dfToleranceEps = `1e-14` |
| ) |  |  |

Add a curve to the container.

The passed geometry is cloned to make an internal copy.

There is no ISO SQL/MM analog to this method.

This method is the same as the C function OGR_G_AddGeometry().

Parameters:

  | poCurve | geometry to add to the container.
  | dfToleranceEps | tolerance when checking that the first point of a segment matches then end point of the previous one. Default value: 1e-14.

Returns:
  OGRERR_NONE if successful, or OGRERR_FAILURE in case of error (for example if curves are not contiguous)

OGRErr OGRCompoundCurve::addCurveDirectly | ( | OGRCurve * | poCurve,
|  | double | dfToleranceEps = `1e-14` |
| ) |  |  |

Add a curve directly to the container.

Ownership of the passed geometry is taken by the container rather than cloning as addCurve() does.

There is no ISO SQL/MM analog to this method.

This method is the same as the C function OGR_G_AddGeometryDirectly().

Parameters:

  | poCurve | geometry to add to the container.
  | dfToleranceEps | tolerance when checking that the first point of a segment matches then end point of the previous one. Default value: 1e-14.

Returns:
  OGRERR_NONE if successful, or OGRERR_FAILURE in case of error (for example if curves are not contiguous)

OGRLinearRing * OGRCompoundCurve::CastToLinearRing | ( | OGRCompoundCurve * | poCC | ) | `[static, protected]`

Cast to linear ring.

The passed in geometry is consumed and a new one returned (or NULL in case of failure)

Parameters:

  | poCC | the input geometry - ownership is passed to the method.

Returns:
  new geometry.

OGRGeometry * OGRCompoundCurve::clone | ( |  | ) | const`[virtual]`

Make a copy of this object.

This method relates to the SFCOM IGeometry::clone() method.

This method is the same as the C function OGR_G_Clone().

Returns:
  a new object instance with the same geometry, and spatial reference system as the original.

Implements OGRGeometry.

OGRLineString * OGRCompoundCurve::CurveToLine | ( | double | dfMaxAngleStepSizeDegrees = `0`,
|  | const char *const * | papszOptions = `NULL` |
| ) |  |  | const`[virtual]`

Return a linestring from a curve geometry.

The returned geometry is a new instance whose ownership belongs to the caller.

If the dfMaxAngleStepSizeDegrees is zero, then a default value will be used. This is currently 4 degrees unless the user has overridden the value with the OGR_ARC_STEPSIZE configuration variable.

This method relates to the ISO SQL/MM Part 3 ICurve::CurveToLine() method.

This function is the same as C function OGR_G_CurveToLine().

Parameters:

  | dfMaxAngleStepSizeDegrees | the largest step in degrees along the arc, zero to use the default setting.
  | papszOptions | options as a null-terminated list of strings or NULL. See OGRGeometryFactory::curveToLineString() for valid options.

Returns:
  a line string approximating the curve

Since:
  GDAL 2.0

Implements OGRCurve.

void OGRCompoundCurve::empty | ( |  | ) | `[virtual]`

Clear geometry information.

This restores the geometry to it's initial state after construction, and before assignment of actual geometry.

This method relates to the SFCOM IGeometry::Empty() method.

This method is the same as the C function OGR_G_Empty().

Implements OGRGeometry.

void OGRCompoundCurve::EndPoint | ( | OGRPoint * | poPoint | ) | const`[virtual]`

Return the curve end point.

This method relates to the SF COM ICurve::get_EndPoint() method.

Parameters:

  | poPoint | the point to be assigned the end location.

Implements OGRCurve.

OGRBoolean OGRCompoundCurve::Equals | ( | OGRGeometry * | poOtherGeom | ) | const`[virtual]`

Returns TRUE if two geometries are equivalent.

This method is the same as the C function OGR_G_Equals().

Returns:
  TRUE if equivalent or FALSE otherwise.

Implements OGRGeometry.

OGRErr OGRCompoundCurve::exportToWkb | ( | OGRwkbByteOrder | eByteOrder,
|  | unsigned char * | pabyData,
|  | OGRwkbVariant | eWkbVariant = `wkbVariantOldOgc` |
| ) |  |  | const`[virtual]`

Convert a geometry into well known binary format.

This method relates to the SFCOM IWks::ExportToWKB() method.

This method is the same as the C function OGR_G_ExportToWkb() or OGR_G_ExportToIsoWkb(), depending on the value of eWkbVariant.

Parameters:

  | eByteOrder | One of wkbXDR or wkbNDR indicating MSB or LSB byte order respectively.
  | pabyData | a buffer into which the binary representation is written. This buffer must be at least OGRGeometry::WkbSize() byte in size.
  | eWkbVariant | What standard to use when exporting geometries with three dimensions (or more). The default wkbVariantOldOgc is the historical OGR variant. wkbVariantIso is the variant defined in ISO SQL/MM and adopted by OGC for SFSQL 1.2.

Returns:
  Currently OGRERR_NONE is always returned.

Implements OGRGeometry.

virtual OGRErr OGRCompoundCurve::exportToWkt | ( | char ** | ppszDstText,
|  | OGRwkbVariant | eWkbVariant = `wkbVariantOldOgc` |
| ) |  |  | const`[virtual]`

Convert a geometry into well known text format.

This method relates to the SFCOM IWks::ExportToWKT() method.

This method is the same as the C function OGR_G_ExportToWkt().

Parameters:

  | ppszDstText | a text buffer is allocated by the program, and assigned to the passed pointer. After use, *ppszDstText should be freed with OGRFree().
  | eWkbVariant | the specification that must be conformed too : wbkVariantOgc for old-style 99-402 extended dimension (Z) WKB types wbkVariantIso for SFSQL 1.2 and ISO SQL/MM Part 3

Returns:
  Currently OGRERR_NONE is always returned.

Implements OGRGeometry.

void OGRCompoundCurve::flattenTo2D | ( |  | ) | `[virtual]`

Convert geometry to strictly 2D.

In a sense this converts all Z coordinates to 0.0.

This method is the same as the C function OGR_G_FlattenTo2D().

Implements OGRGeometry.

double OGRCompoundCurve::get_Area | ( |  | ) | const`[virtual]`

Get the area of the (closed) curve.

This method is designed to be used by OGRCurvePolygon::get_Area().

Returns:
  the area of the feature in square units of the spatial reference system in use.

Since:
  GDAL 2.0

Implements OGRCurve.

double OGRCompoundCurve::get_AreaOfCurveSegments | ( |  | ) | const`[virtual]`

Get the area of the purely curve portions of a (closed) curve.

This method is designed to be used on a closed convex curve.

Returns:
  the area of the feature in square units of the spatial reference system in use.

Since:
  GDAL 2.0

Implements OGRCurve.

double OGRCompoundCurve::get_Length | ( |  | ) | const`[virtual]`

Returns the length of the curve.

This method relates to the SFCOM ICurve::get_Length() method.

Returns:
  the length of the curve, zero if the curve hasn't been initialized.

Implements OGRCurve.

OGRCurve * OGRCompoundCurve::getCurve | ( | int | i | ) |

Fetch reference to indicated internal ring.

Note that the returned curve pointer is to an internal data object of the OGRCompoundCurve. It should not be modified or deleted by the application, and the pointer is only valid till the polygon is next modified. Use the OGRGeometry::clone() method to make a separate copy within the application.

Relates to the ISO SQL/MM ST_CurveN() function.

Parameters:

  | iRing | curve index from 0 to getNumCurves() - 1.

Returns:
  pointer to curve. May be NULL.

const OGRCurve * OGRCompoundCurve::getCurve | ( | int | i | ) | const

Fetch reference to indicated internal ring.

Note that the returned curve pointer is to an internal data object of the OGRCompoundCurve. It should not be modified or deleted by the application, and the pointer is only valid till the polygon is next modified. Use the OGRGeometry::clone() method to make a separate copy within the application.

Relates to the ISO SQL/MM ST_CurveN() function.

Parameters:

  | iRing | curve index from 0 to getNumCurves() - 1.

Returns:
  pointer to curve. May be NULL.

void OGRCompoundCurve::getEnvelope | ( | OGREnvelope * | psEnvelope | ) | const`[virtual]`

Computes and returns the bounding envelope for this geometry in the passed psEnvelope structure.

This method is the same as the C function OGR_G_GetEnvelope().

Parameters:

  | psEnvelope | the structure in which to place the results.

Implements OGRGeometry.

void OGRCompoundCurve::getEnvelope | ( | OGREnvelope3D * | psEnvelope | ) | const`[virtual]`

Computes and returns the bounding envelope (3D) for this geometry in the passed psEnvelope structure.

This method is the same as the C function OGR_G_GetEnvelope3D().

Parameters:

  | psEnvelope | the structure in which to place the results.

Since:
  OGR 1.9.0

Implements OGRGeometry.

const char * OGRCompoundCurve::getGeometryName | ( |  | ) | const`[virtual]`

Fetch WKT name for geometry type.

There is no SFCOM analog to this method.

This method is the same as the C function OGR_G_GetGeometryName().

Returns:
  name used for this geometry type in well known text format. The returned pointer is to a static internal string and should not be modified or freed.

Implements OGRGeometry.

OGRwkbGeometryType OGRCompoundCurve::getGeometryType | ( |  | ) | const`[virtual]`

Fetch geometry type.

Note that the geometry type may include the 2.5D flag. To get a 2D flattened version of the geometry type apply the wkbFlatten() macro to the return result.

This method is the same as the C function OGR_G_GetGeometryType().

Returns:
  the geometry type code.

Implements OGRGeometry.

int OGRCompoundCurve::getNumCurves | ( |  | ) | const

Return the number of curves.

Note that the number of curves making this compound curve.

Relates to the ISO SQL/MM ST_NumCurves() function.

Returns:
  number of curves.

int OGRCompoundCurve::getNumPoints | ( |  | ) | const`[virtual]`

Return the number of points of a curve geometry.

This method, as a method of OGRCurve, does not relate to a standard. For circular strings or linestrings, it returns the number of points, conforming to SF COM NumPoints(). For compound curves, it returns the sum of the number of points of each of its components (non including intermediate starting/ending points of the different parts).

Returns:
  the number of points of the curve.

Since:
  GDAL 2.0

Implements OGRCurve.

OGRPointIterator * OGRCompoundCurve::getPointIterator | ( |  | ) | const`[virtual]`

Returns a point iterator over the curve.

The curve must not be modified while an iterator exists on it.

The iterator must be destroyed with OGRPointIterator::destroy().

Returns:
  a point iterator over the curve.

Since:
  GDAL 2.0

Implements OGRCurve.

OGRErr OGRCompoundCurve::importFromWkb | ( | unsigned char * | pabyData,
|  | int | nSize = `-1`,
|  | OGRwkbVariant | eWkbVariant = `wkbVariantOldOgc` |
| ) |  |  | `[virtual]`

Assign geometry from well known binary data.

The object must have already been instantiated as the correct derived type of geometry object to match the binaries type. This method is used by the OGRGeometryFactory class, but not normally called by application code.

This method relates to the SFCOM IWks::ImportFromWKB() method.

This method is the same as the C function OGR_G_ImportFromWkb().

Parameters:

  | pabyData | the binary input data.
  | nSize | the size of pabyData in bytes, or zero if not known.
  | eWkbVariant | if wkbVariantPostGIS1, special interpretation is done for curve geometries code

Returns:
  OGRERR_NONE if all goes well, otherwise any of OGRERR_NOT_ENOUGH_DATA, OGRERR_UNSUPPORTED_GEOMETRY_TYPE, or OGRERR_CORRUPT_DATA may be returned.

Implements OGRGeometry.

OGRErr OGRCompoundCurve::importFromWkt | ( | char ** | ppszInput | ) | `[virtual]`

Assign geometry from well known text data.

The object must have already been instantiated as the correct derived type of geometry object to match the text type. This method is used by the OGRGeometryFactory class, but not normally called by application code.

This method relates to the SFCOM IWks::ImportFromWKT() method.

This method is the same as the C function OGR_G_ImportFromWkt().

Parameters:

  | ppszInput | pointer to a pointer to the source text. The pointer is updated to pointer after the consumed text.

Returns:
  OGRERR_NONE if all goes well, otherwise any of OGRERR_NOT_ENOUGH_DATA, OGRERR_UNSUPPORTED_GEOMETRY_TYPE, or OGRERR_CORRUPT_DATA may be returned.

Implements OGRGeometry.

OGRBoolean OGRCompoundCurve::IsEmpty | ( |  | ) | const`[virtual]`

Returns TRUE (non-zero) if the object has no points.

Normally this returns FALSE except between when an object is instantiated and points have been assigned.

This method relates to the SFCOM IGeometry::IsEmpty() method.

Returns:
  TRUE if object is empty, otherwise FALSE.

Implements OGRGeometry.

void OGRCompoundCurve::segmentize | ( | double | dfMaxLength | ) | `[virtual]`

Add intermediate vertices to a geometry.

This method modifies the geometry to add intermediate vertices if necessary so that the maximum length between 2 consecutives vertices is lower than dfMaxLength.

Parameters:

  | dfMaxLength | maximum length between 2 consecutives vertices.

Reimplemented from OGRGeometry.

void OGRCompoundCurve::setCoordinateDimension | ( | int | nNewDimension | ) | `[virtual]`

Set the coordinate dimension.

This method sets the explicit coordinate dimension. Setting the coordinate dimension of a geometry to 2 should zero out any existing Z values. Setting the dimension of a geometry collection will not necessarily affect the children geometries.

Parameters:

  | nNewDimension | New coordinate dimension value, either 2 or 3.

Reimplemented from OGRGeometry.

void OGRCompoundCurve::StartPoint | ( | OGRPoint * | poPoint | ) | const`[virtual]`

Return the curve start point.

This method relates to the SF COM ICurve::get_StartPoint() method.

Parameters:

  | poPoint | the point to be assigned the start location.

Implements OGRCurve.

void OGRCompoundCurve::swapXY | ( |  | ) | `[virtual]`

Swap x and y coordinates.

Since:
  OGR 1.8.0

Reimplemented from OGRGeometry.

OGRErr OGRCompoundCurve::transform | ( | OGRCoordinateTransformation * | poCT | ) | `[virtual]`

Apply arbitrary coordinate transformation to geometry.

This method will transform the coordinates of a geometry from their current spatial reference system to a new target spatial reference system. Normally this means reprojecting the vectors, but it could include datum shifts, and changes of units.

Note that this method does not require that the geometry already have a spatial reference system. It will be assumed that they can be treated as having the source spatial reference system of the OGRCoordinateTransformation object, and the actual SRS of the geometry will be ignored. On successful completion the output OGRSpatialReference of the OGRCoordinateTransformation will be assigned to the geometry.

This method is the same as the C function OGR_G_Transform().

Parameters:

  | poCT | the transformation to apply.

Returns:
  OGRERR_NONE on success or an error code.

Implements OGRGeometry.

void OGRCompoundCurve::Value | ( | double | dfDistance,
|  | OGRPoint * | poPoint |
| ) |  |  | const`[virtual]`

Fetch point at given distance along curve.

This method relates to the SF COM ICurve::get_Value() method.

This function is the same as the C function OGR_G_Value().

Parameters:

  | dfDistance | distance along the curve at which to sample position. This distance should be between zero and get_Length() for this curve.
  | poPoint | the point to be assigned the curve position.

Implements OGRCurve.

int OGRCompoundCurve::WkbSize | ( |  | ) | const`[virtual]`

Returns size of related binary representation.

This method returns the exact number of bytes required to hold the well known binary representation of this geometry object. Its computation may be slightly expensive for complex geometries.

This method relates to the SFCOM IWks::WkbSize() method.

This method is the same as the C function OGR_G_WkbSize().

Returns:
  size of binary representation in bytes.

Implements OGRGeometry.

The documentation for this class was generated from the following files:

- ogr_geometry.h
- ogrcompoundcurve.cpp

Generated for GDAL by 1.7.1.